#!/bin/sh
# $Id: update-countries.sh,v 1.3 2008/03/11 19:07:41 maxim Exp $
#
# updates Geo-IP DB from MaxMind and converts to own format;
# 0W-httpd must be configured with country support to handle this list:
# ./configure --with-country
#
# required: wget or fetch, unzip or gzip (not FreeBSD gzip)
#


EXEC_DIR=`dirname $0`
CUR_DIR=`pwd`
case "$EXEC_DIR" in
    /*) DIR="$EXEC_DIR";;
    *) DIR="$CUR_DIR/$EXEC_DIR";;
esac

which fetch > /dev/null 2>&1 && FETCH="fetch -qM"
which wget > /dev/null 2>&1 && FETCH="wget -qN"
test -z "$FETCH" && echo "error: no fetcher" && exit

which gzip > /dev/null 2>&1 && test `gzip -V 2>&1 | awk '{print $1;exit}'` != "FreeBSD" && UNZIP="gzip -dc"
which unzip > /dev/null 2>&1 && UNZIP="unzip -p"
test -z "$UNZIP" && echo "error: no unzip" && exit



cd $DIR/../conf || exit

echo Getting &&
$FETCH http://www.maxmind.com/download/geoip/database/GeoIPCountryCSV.zip &&
echo Checking &&
(test ! -s countries.ips || test GeoIPCountryCSV.zip -nt countries.ips) &&
echo Unzipping &&
$UNZIP GeoIPCountryCSV.zip > GeoIPCountryWhois.csv &&
echo Converting &&
$DIR/convert-geoip < GeoIPCountryWhois.csv &&
echo Done &&
rm GeoIPCountryWhois.csv ||
echo Nope

echo Getting russian regions &&
$FETCH http://0w.ru/httpd/conf/regions.ips &&
echo Done
